function CreateFigure3
%Create figure 3

%Set the range of x, and the different standard deviation values
x = -10:0.01:10;
sigma = 1:0.25:3;

%Create the Gaussian curves
for(i = 1:length(sigma))
    y{i} = 1./(sqrt(2*pi).*sigma(i)).*exp(-x.^2/(2*sigma(i)^2));
    parameters.YData{i} = y{i};
    parameters.XData{i} = x;
    parameters.colorStyle{i} = 'k';
end

%Show the results
parameters.XLabels{1} = 'Displacement';
parameters.YLabels{1} = 'Probability';
bimagic_plot(parameters);