%%%Produce a figure showing a model being learnt
ClearData

%Create a trajectory
%sigma = [2];

numDimensions = 1;
numFrames = 100;
cellBoundary = 10;
sigmaLowHigh = [0 5];
muLowHigh = [-0.1 0.1];
resolution = 0.2;
numParticles = 100000;
numPriorParticles = 1000;

for i = 1:numFrames
    pixelBoundary{i} = 0:resolution:cellBoundary;
end

numTrajectories = 1;
numObjects = 1;

clear parameters;
clear predictions;
clear estUncertainty;
parameters.XLabels{1} = 'Frame number';
parameters.YLabels{1} = 'Error';
parameters.plotTitle = 'Model Learning';

for(i = 1:5)
parameters.YData{i} = 0;
captured{i} = 0;
estUncertainty{i} = 0;
futureUncertainty{i} = 0;
end


for(iTrajectory = 1:numTrajectories)
    for(iObject = 1:numObjects)
        sigma{iObject} = rand(1,1)*(sigmaLowHigh(2) - sigmaLowHigh(1))+sigmaLowHigh(1);
        mu{iObject} = rand(1,1)*(muLowHigh(2) - muLowHigh(1))+muLowHigh(1);
        truth{iObject} = [sigma{iObject} mu{iObject}];
        position{iObject} = CreateTrajectory(length(sigma{1}), cellBoundary,numFrames,sigma{iObject},mu{iObject},-1);
    end
    iTrajectory
    intelligentAcquisition = InitializeIntelligentAcquisition();
    priorParticles = rand(numPriorParticles, 2*numDimensions+1)*(sigmaLowHigh(2) - sigmaLowHigh(1)) + sigmaLowHigh(1);
    priorParticles(:,(numDimensions+1):(2*numDimensions)) = rand(size(priorParticles(:,(numDimensions+1):(2*numDimensions))))*(muLowHigh(2) - muLowHigh(1)) + muLowHigh(1);
    priorParticles(:,2*numDimensions+1) = 1/numPriorParticles;
    
    intelligentAcquisition.whereToAcquire = 3;
%    intelligentAcquisition.whereToAcquire = 5;
%    intelligentAcquisition.chosenPixels = 1;
    intelligentAcquisition.numPixels = 0;
    [predictions{1},uncertainty,testUncertainty, tfutureUncertainty, particle, tcaptured, output] = LearnModel([1 1 1 1],position, cellBoundary, numParticles, pixelBoundary, truth, intelligentAcquisition,priorParticles);
    parameters.XData{1} = 1:numFrames;
    parameters.YData{1} = parameters.YData{1}+output.mallows;
    captured{1} = captured{1} + tcaptured;
    estUncertainty{1} = estUncertainty{1} + testUncertainty;
    futureUncertainty{1} = futureUncertainty{1} + tfutureUncertainty;
    parameters.colorStyle{1} = 'k';
    parameters.lineStyle{1} = ':';
    
    intelligentAcquisition.whereToAcquire = 1;
     %   intelligentAcquisition.whereToAcquire = 5;
    %intelligentAcquisition.chosenPixels = 2;
    intelligentAcquisition.numPixels = 13;
    [predictions{2},uncertainty,testUncertainty, tfutureUncertainty, particle, tcaptured,output] = LearnModel([1 1 1 1],position, cellBoundary, numParticles, pixelBoundary, truth,intelligentAcquisition,priorParticles);
    parameters.XData{2} = 1:numFrames;
    if(isnan(sum(uncertainty)))
        a=1;
    end
    parameters.YData{2} = parameters.YData{2}+output.mallows;
    captured{2} = captured{2} + tcaptured;
        estUncertainty{2} = estUncertainty{2} + testUncertainty;
            futureUncertainty{2} = futureUncertainty{2} + tfutureUncertainty;
    parameters.colorStyle{2} = 'r';

    intelligentAcquisition.whereToAcquire = 2;
 %       intelligentAcquisition.whereToAcquire = 5;
  %  intelligentAcquisition.chosenPixels = 3;
%    intelligentAcquisition.numPixels = 1;
    [predictions{3},uncertainty,testUncertainty, tfutureUncertainty, particle, tcaptured,output] = LearnModel([1 1 1 1],position, cellBoundary, numParticles, pixelBoundary, truth,intelligentAcquisition,priorParticles);
    parameters.XData{3} = 1:numFrames;
    parameters.YData{3} = parameters.YData{3}+output.mallows;
        captured{3} = captured{3} + tcaptured;
            estUncertainty{3} = estUncertainty{3} + testUncertainty;
                futureUncertainty{3} = futureUncertainty{3} + tfutureUncertainty;
    parameters.colorStyle{3} = 'b';
    parameters.lineStyle{3} = '--';
    
    intelligentAcquisition.whereToAcquire = 3;
   %     intelligentAcquisition.whereToAcquire = 5;
    %intelligentAcquisition.chosenPixels = 4;
%    intelligentAcquisition.numPixels = 1;
    [predictions{4},uncertainty,testUncertainty, tfutureUncertainty, particle, tcaptured,output] = LearnModel([1 1 1 1],position, cellBoundary, numParticles, pixelBoundary, truth,intelligentAcquisition,priorParticles);
    parameters.XData{4} = 1:numFrames;
    parameters.YData{4} = parameters.YData{4}+output.mallows;
    captured{4} = captured{4} + tcaptured;
        estUncertainty{4} = estUncertainty{4} + testUncertainty;
            futureUncertainty{4} = futureUncertainty{4} + tfutureUncertainty;
    parameters.colorStyle{4} = 'k';
    parameters.lineStyle{4} = '-.';
 
    intelligentAcquisition.whereToAcquire = 6;
    intelligentAcquisition.numPixels = 13;
    [predictions{5},uncertainty,testUncertainty, tfutureUncertainty, particle, tcaptured,output] = LearnModel([1 1 1 1],position, cellBoundary, numParticles, pixelBoundary, truth,intelligentAcquisition,priorParticles);
    parameters.XData{5} = 1:numFrames;
    parameters.YData{5} = parameters.YData{5}+output.mallows;
        captured{5} = captured{5} + tcaptured;
    parameters.colorStyle{5} = 'm';
end

%normalize
normFactor = parameters.YData{1}(1);
parameters.YData{1} = parameters.YData{1}/normFactor;
parameters.YData{2} = parameters.YData{2}/normFactor;
parameters.YData{3} = parameters.YData{3}/normFactor;
parameters.YData{4} = parameters.YData{4}/normFactor;
parameters.YData{5} = parameters.YData{5}/normFactor;
parameters.YRange{1} = [0 1];

parameters2 = parameters;
parameters2.XData{1} = cumsum(captured{1});
parameters2.XData{2} = cumsum(captured{2});
parameters2.XData{3} = cumsum(captured{3});
parameters2.XData{4} = cumsum(captured{4});
parameters2.XData{5} = cumsum(captured{5});

save(['parameters_intell' num2str(rand(1)) '.mat'])

% parameters  = bimagic_plot(parameters);
% FormatFigure;
% saveas(gcf, 'IntelligentLearning.fig', 'fig')
% print -depsc C:\\Research\\Journal\\08_02_IP_ActiveMasks\\Figures\\IntelligentLearning
% save intelligentlearning.mat parameters


