function [pixel] = FindPixels(pixelBoundaries, particle, numDimensions)

%Initialize the pixel array
pixel = zeros(size(particle,1),numDimensions+1);

%For each dimension, assign the appropriate pixel index in this dimension
for iDimension = 1:numDimensions
    for iBoundary = 1:(length(pixelBoundaries)-1)       
        pixel(particle(:,iDimension)>pixelBoundaries(iBoundary) & particle(:,iDimension) <= pixelBoundaries(iBoundary + 1), iDimension) = iBoundary;
    end
end

%For the final column of the pixel array, assign a unique value for that
%pixel
for iDimension = 1:numDimensions
    pixel(:,numDimensions+1) = pixel(:,numDimensions+1) + (pixel(:,iDimension)-1) * (length(pixelBoundaries)-1)^(iDimension-1);
end
pixel(:,numDimensions+1) = pixel(:,numDimensions+1)+1;