function particle = MoveParticles(particle, numDimensions, cellBoundary)
%Propagate the particles forward according to their motion models

%Move the particles
particle(:,1:numDimensions) = particle(:,1:numDimensions) + particle(:,(2*numDimensions+1):(3*numDimensions)) + randn(size(particle,1),numDimensions).*particle(:,numDimensions+1:(2*numDimensions));

%If a particle would move outside of the cell, let it "bounce" off the
%boundary
for iDimension = 1:numDimensions
    indices1 = find(particle(:,iDimension) < 0);
    indices2 = find(particle(:,iDimension) > cellBoundary);
    while(length(indices1)+length(indices2) > 0)
        particle(indices1,iDimension) = -particle(indices1,iDimension);
        particle(indices2,iDimension) = 2*cellBoundary - particle(indices2,iDimension);
        indices1 = find(particle(:,iDimension) < 0);
        indices2 = find(particle(:,iDimension) > cellBoundary);
    end
end