function futureUncertainty = PredictUncertainty(particle, particleUnknownStart, particleMetaStart, numDimensions, pixel)
%Predict the uncertainty after the proposed acquisition

futureUncertainty = 0;

%Loop through the pixels and find the particles in each pixel
maxPixel = max(pixel(:,numDimensions+1));
for iPixel = 0:maxPixel
    indices = find(pixel(:,numDimensions+1)==iPixel);
    
    %Estimate the uncertainty if the object is in this pixel, weighted by
    %the probability of this event
    if(~isempty(indices))
        futureUncertainty = futureUncertainty + length(indices)*2*sum(var(particle(indices,particleUnknownStart+1:particleMetaStart)));
    end
end
futureUncertainty = futureUncertainty / size(particle,1);